// -*-c++-*-
#include "bhv_tkzw_shoot.h" 

#include <rcsc/action/body_kick_multi_step.h>
#include <rcsc/action/neck_scan_field.h>
#include <rcsc/action/neck_turn_to_low_conf_teammate.h>

#include <rcsc/player/player_agent.h>
#include <rcsc/player/debug_client.h>

#include <rcsc/common/logger.h>
#include <rcsc/common/server_param.h>
#include <rcsc/geom/sector_2d.h>

bool 
Bhv_TkzwShoot::execute( rcsc::PlayerAgent * agent ) 
{
  rcsc::dlog.addText( rcsc::Logger::TEAM,
		      "%s:%d: Bhv_BasicOffensiveKick"
		      ,__FILE__, __LINE__ );
  
  const rcsc::WorldModel & wm = agent->world();
  
  rcsc::Vector2D shoot_p1( 52.5,
			      5.0 - rand() % 2 * 10.0
			     ) ;

  rcsc::Vector2D shoot_p2( 52.5,
			     ( wm.self().pos().y ) /
			     fabs( wm.self().pos().y ) * ( -5.0 ) 
			     ) ;

  
  if ( std::fabs( wm.self().pos().y ) <= 3.0)
    {
      rcsc::Body_KickMultiStep( shoot_p2,
				rcsc::ServerParam::i().ballSpeedMax(),
				 true ).execute( agent ) ;
      rcsc::dlog.addText( rcsc::Logger::TEAM,
			    "%s:%d: TKZW SHOOT P1"
			    ,__FILE__, __LINE__ );

    } 
  else
    {
      rcsc::Body_KickMultiStep( shoot_p1,
				rcsc::ServerParam::i().ballSpeedMax(),
				true ).execute( agent ) ;
      rcsc::dlog.addText( rcsc::Logger::TEAM,
			  "%s:%d: TKZW SHOOT P2"
			  ,__FILE__, __LINE__ );

    }
  agent->setNeckAction( new rcsc::Neck_TurnToLowConfTeammate() );

  return true ;
}
