// -*-c++*-

/*
 *Copyright:

 Copyright (C) Takashi TAKIZAWA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef AGENT2D_PARAMETER_H
#define AGENT2D_PARAMETER_H

#include <boost/shared_ptr.hpp>

#include "strategy.h"

class AttributeParam{
 public:
  static const double OF_SHOOT_PARAM ;
  static const double DF_SHOOT_PARAM ;
  static const double OF_PASS_PARAM ;
  static const double DF_PASS_PARAM ;
  static const double OF_DRIBBLE_PARAM ;
  static const double DF_DRIBBLE_PARAM ;

 public:
  AttributeParam() ;
  //  double get_shoot_param( Strategy::StrategyState state ) ;
  double get_shoot_param( const long & gamecycle ) ;
  double get_pass_param( const long & gamecycle ) ;
  double get_dribble_param( const long & gamecycle ) ;

  enum StrategyState {
    SS_Offensive, SS_Defensive, SS_Normal,

    SS_None
  } ;

 private:
  AttributeParam::StrategyState get_strategy_state( const long & gamecycle ) ;
} ;
#endif
